#include "gpib/ib.h"
#include <time.h>
#include <stdio.h>
/*****************************************************************************
 *                      Function GPIBERROR
 * This function will notify you that a NI-488 function failed by
 * printing an error message.  The status variable IBSTA will also be
 * printed in hexadecimal along with the mnemonic meaning of the bit
 * position. The status variable IBERR will be printed in decimal
 * along with the mnemonic meaning of the decimal value.  The status
 * variable IBCNTL will be printed in decimal.
 *
 * The NI-488 function IBONL is called to disable the hardware and
 * software.
 *
 * The EXIT function will terminate this program.
 *****************************************************************************/
void
GpibError (char *msg)
{
  time_t t = time(0);
  printf(ctime(&t));
  printf ("%s\n", msg);

  printf ("ibsta = &H%x  <", ibsta);
  if (ibsta & ERR)
    printf (" ERR");
  if (ibsta & TIMO)
    printf (" TIMO");
  if (ibsta & END)
    printf (" END");
  if (ibsta & SRQI)
    printf (" SRQI");
  if (ibsta & RQS)
    printf (" RQS");
  if (ibsta & CMPL)
    printf (" CMPL");
  if (ibsta & LOK)
    printf (" LOK");
  if (ibsta & REM)
    printf (" REM");
  if (ibsta & CIC)
    printf (" CIC");
  if (ibsta & ATN)
    printf (" ATN");
  if (ibsta & TACS)
    printf (" TACS");
  if (ibsta & LACS)
    printf (" LACS");
  if (ibsta & DTAS)
    printf (" DTAS");
  if (ibsta & DCAS)
    printf (" DCAS");
  printf (" >\n");

  printf ("iberr = %d", iberr);
  if (iberr == EDVR)
    printf (" EDVR <Driver Error>\n");
  if (iberr == ECIC)
    printf (" ECIC <Not Controller-In-Charge>\n");
  if (iberr == ENOL)
    printf (" ENOL <No Listener>\n");
  if (iberr == EADR)
    printf (" EADR <Address error>\n");
  if (iberr == EARG)
    printf (" EARG <Invalid argument>\n");
  if (iberr == ESAC)
    printf (" ESAC <Not System Controller>\n");
  if (iberr == EABO)
    printf (" EABO <Operation aborted>\n");
  if (iberr == ENEB)
    printf (" ENEB <No GPIB board>\n");
  if (iberr == EDMA)
    printf (" EDMA <DMA Error>\n");
  if (iberr == EOIP)
    printf (" EOIP <Async I/O in progress>\n");
  if (iberr == ECAP)
    printf (" ECAP <No capability>\n");
  if (iberr == EFSO)
    printf (" EFSO <File system error>\n");
  if (iberr == EBUS)
    printf (" EBUS <Command error>\n");
  if (iberr == ESRQ)
    printf (" ESRQ <SRQ stuck on>\n");
  if (iberr == ETAB)
    printf (" ETAB <Table Overflow>\n");
  /*  if (iberr == ELCK)
      printf (" ELCK <Interface is locked>\n"); *
  if (iberr == EARM)
    printf (" EARM <ibnotify callback failed to rearm>\n");
  if (iberr == EHDL)
    printf (" EHDL <Input handle is invalid>\n");
  if (iberr == EWIP)
    printf (" EWIP <Wait in progress on specified input handle>\n");
  if (iberr == ERST)
    printf
      (" ERST <The event notification was cancelled due to a reset of the interface>\n");
  if (iberr == EPWR)
  printf (" EPWR <The interface lost power>\n"); */

  printf ("ibcntl = %ld\n", ibcntl);
  printf ("\n");

  /* Call ibonl to take the device and interface offline 
  ibonl (Device, 0);

     exit(1); */
}
